<?php

namespace Tests;

use Zeedhi\Framework\DependencyInjection\InstanceManager;

class Util {
    public const DEFAULT_PK = 999999999999;
    public const DEFAULT_ORG = 20;

    /**
     * Retorna a entidade de manipulacao de instancias
     * @return InstanceManager
     */
    public static function getInstanceManager(): InstanceManager {
        return InstanceManager::getInstance();
    }

    /**
     * Retorna a entidade de conexao com a base de dados
     * @return \Doctrine\DBAL\Connection
     */
    public static function getConnection(): \Doctrine\DBAL\Connection {
        return self::getInstanceManager()
            ->getService('entitymanager')
            ->getConnection();
    }

    /**
     * Define a sessao padrao para os casos de teste
     * @return void
     */
    public static function setDefaultTestSession(): void {
        $session = self::getInstanceManager()->getService('session');
        $session->set("NRORG", self::DEFAULT_ORG);
        $session->set("NRORGTRAB", self::DEFAULT_ORG);
    }
}