/* Sistemas Integrados TEKNISA
  Controle de Produo

Nome: 3935_CDPFUNS_CALCULA_CUSTO_SOBRA.SQL

Descrio:
Funo para retornar o custo do produto produzido a parte na ordem de produo consolidada

Criao:
02/08/2007 Welbert Gonalves Moitinha
*/


IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'CALCULA_CUSTO_SOBRA' AND
                 TYPE = 'FN' 		      AND
	              U.UID = O.UID           AND
	              U.NAME = USER)
DROP FUNCTION CALCULA_CUSTO_SOBRA
GO

CREATE FUNCTION CALCULA_CUSTO_SOBRA (
        @P_CDFILIAL     VARCHAR(4),
        @P_NRORDPROD    VARCHAR(10),
        @P_NRSUBORDPROD VARCHAR(1),
        @P_CDPRODSOBRA  VARCHAR(20),
        @P_CDMATPRIMA   VARCHAR(20),
        @P_NRTIPOCUSTO  INTEGER
) RETURNS DOUBLE PRECISION
AS
BEGIN
   DECLARE @V_CDMATPRIMA   VARCHAR(10);
   DECLARE @V_IDRATCUSPROD VARCHAR(1);
   DECLARE @V_VRPERCUSMAT  DOUBLE PRECISION;
   DECLARE @V_CUSTOPROD    DOUBLE PRECISION;
   DECLARE @V_CUSTOTOTAL   DOUBLE PRECISION;
   DECLARE @V_CDPRODPERDA  VARCHAR(10);
   DECLARE @V_CONTREG      INTEGER;

   SET @V_CUSTOTOTAL = 0;

   SELECT  @V_CONTREG = COUNT(*)
   FROM PRODUTO
   WHERE
      CDARVPROD = @P_CDPRODSOBRA;

   IF @V_CONTREG > 0 BEGIN
      SELECT @V_CDPRODPERDA = CDPRODUTO
      FROM PRODUTO
      WHERE
         CDARVPROD = @P_CDPRODSOBRA;
   END
   ELSE BEGIN
      SET @V_CDPRODPERDA = '';
   END;

   SELECT @V_CONTREG = CDPRODUTO
   FROM PRODUTO
   WHERE
      CDARVPROD = @P_CDMATPRIMA;

   IF @V_CONTREG > 0 BEGIN
      SELECT @V_CDMATPRIMA = CDPRODUTO
      FROM PRODUTO
      WHERE
         CDARVPROD = @P_CDMATPRIMA;
   END
   ELSE BEGIN
      SET @V_CDMATPRIMA = '';
   END;

   IF @V_CDMATPRIMA IS NOT NULL BEGIN

      SELECT
         @V_CUSTOPROD = SUM(ROUND( TEKNISA.CUSTO_PRODUTO_LCEST(@P_CDFILIAL, I.CDPRODUTO, @P_NRTIPOCUSTO,
                                                               I.DTRETPROD, I.DTRETPROD, L.CDALMOXARIFE, L.CDLOCALESTOQ,
                                                               L.NRLOTEESTQ, L.NRSUBLOTE), 5) * I.QTPRERETPROD) / SUM(I.QTPRERETPROD)
      FROM
         RETIRADAESTO R, ITEMRETIEST I, LOTITRETIEST L
      WHERE
         I.CDFILIAL     = @P_CDFILIAL    AND
         R.NRORDPROD    = @P_NRORDPROD    AND
         R.NRSUBORDPROD = @P_NRSUBORDPROD AND
         I.CDPRODUTO    = @V_CDMATPRIMA AND
         I.CDFILIAL     = R.CDFILIAL AND
         I.NRRETEST     = R.NRRETEST AND
         I.CDFILIAL     = L.CDFILIAL AND
         I.NRRETEST     = L.NRRETEST AND
         I.CDPRODUTO    = L.CDPRODUTO AND
         L.IDTPRETEST   = 'R';

      SELECT
         @V_IDRATCUSPROD = IDRATCUSPROD,
         @V_VRPERCUSMAT  = VRPERCUSMAT
      FROM PARPRODOPCONS
      WHERE
          CDFILIAL   = @P_CDFILIAL AND
          CDMATPRIMA = @V_CDMATPRIMA AND
          CDPRODUTO  = @V_CDPRODPERDA;


      IF @V_IDRATCUSPROD = 'N' BEGIN
         SET @V_CUSTOTOTAL = @V_CUSTOPROD * (@V_VRPERCUSMAT/100);
      END
      ELSE BEGIN
         SET @V_CUSTOTOTAL = @V_CUSTOPROD;
      END;
   END;
  RETURN(@V_CUSTOTOTAL);
END
GO

-- VERSAO --
BEGIN ATUVEROBJ('CALCULA_CUSTO_SOBRA','4.11.159';
GO


